-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt
local M = {}
M.type = "auxilliary"
M.relevantDevice = mainEngine_R, mainEngine_L, mainMotor;
M.throttle_M = 0
M.throttle_R = 0
M.throttle_L = 0

local min = math.min
local max = math.max
local abs = math.abs



--local span = nil

local function updateGFX(dt)


  local throttle_R = min(max(electrics.values.throttle_R, 0), 1)
  local throttle_M = min(max(electrics.values.throttle_M, 0), 1)
  local throttle_L = min(max(electrics.values.throttle_L, 0), 1)  

  
if electrics.values.gear == "N" then 
	if electrics.values.steering_input > 0.05 then
		powertrain.getDevice("mainEngine_L").motorDirection = 1

		powertrain.getDevice("mainEngine_R").motorDirection = -1
		powertrain.getDevice("mainMotor").motorDirection = 0

				electrics.values.throttle_R =  electrics.values.throttle
				electrics.values.throttle_M =  electrics.values.throttle
				electrics.values.throttle_L = electrics.values.throttle


	elseif electrics.values.steering_input < -0.05 then
		powertrain.getDevice("mainEngine_L").motorDirection = -1

		powertrain.getDevice("mainEngine_R").motorDirection = 1
		powertrain.getDevice("mainMotor").motorDirection = 0

				electrics.values.throttle_R =  electrics.values.throttle
				electrics.values.throttle_M =  electrics.values.throttle
				electrics.values.throttle_L = electrics.values.throttle


	else 
		powertrain.getDevice("mainEngine_L").motorDirection = -1
		powertrain.getDevice("mainEngine_R").motorDirection = -1
		powertrain.getDevice("mainMotor").motorDirection = 0	

				electrics.values.throttle_R =  electrics.values.throttle
				electrics.values.throttle_M =  electrics.values.throttle
				electrics.values.throttle_L = electrics.values.throttle		

	end 
elseif electrics.values.gear == "S" then 
	if electrics.values.steering_input > 0.05 then
			if electrics.values.steering_input > 0.9 then
				powertrain.getDevice("mainEngine_L").motorDirection = 1

				powertrain.getDevice("mainEngine_R").motorDirection = -1
				powertrain.getDevice("mainMotor").motorDirection = 0

				electrics.values.throttle_R =  electrics.values.throttle
				electrics.values.throttle_M =  electrics.values.throttle
				electrics.values.throttle_L = electrics.values.throttle
	
	

			else
				powertrain.getDevice("mainEngine_L").motorDirection = 1
				powertrain.getDevice("mainEngine_R").motorDirection = 1
				powertrain.getDevice("mainMotor").motorDirection = 0


				electrics.values.throttle_M =  electrics.values.throttle
				electrics.values.throttle_R =  electrics.values.throttle-(max(electrics.values.steering_input*3, 0))
				electrics.values.throttle_L = electrics.values.throttle-(max(-electrics.values.steering_input*3, 0)) 

			end
	elseif electrics.values.steering_input < -0.05 then
			if electrics.values.steering_input < -0.9 then
				powertrain.getDevice("mainEngine_L").motorDirection = -1

				powertrain.getDevice("mainEngine_R").motorDirection = 1
				powertrain.getDevice("mainMotor").motorDirection = 0

				electrics.values.throttle_R =  electrics.values.throttle
				electrics.values.throttle_M =  electrics.values.throttle
				electrics.values.throttle_L = electrics.values.throttle
	
	

			else
				powertrain.getDevice("mainEngine_L").motorDirection = 1
				powertrain.getDevice("mainEngine_R").motorDirection = 1
				powertrain.getDevice("mainMotor").motorDirection = 0


				electrics.values.throttle_M =  electrics.values.throttle
				electrics.values.throttle_R =  electrics.values.throttle-(max(electrics.values.steering_input*3, 0))
				electrics.values.throttle_L = electrics.values.throttle-(max(-electrics.values.steering_input*3, 0)) 

			end

	else 
		powertrain.getDevice("mainEngine_L").motorDirection = 1
		powertrain.getDevice("mainEngine_R").motorDirection = 1
		powertrain.getDevice("mainMotor").motorDirection = 0	

				electrics.values.throttle_R =  electrics.values.throttle
				electrics.values.throttle_M =  electrics.values.throttle
				electrics.values.throttle_L = electrics.values.throttle		
	end 

	
else
  		powertrain.getDevice("mainEngine_L").motorDirection = 0
		powertrain.getDevice("mainEngine_R").motorDirection = 0



				electrics.values.throttle_R =  electrics.values.throttle
				electrics.values.throttle_M =  electrics.values.throttle
				electrics.values.throttle_L = electrics.values.throttle


  
 end  
  
  


  



 
end

local function init(jbeamData)

  
  electrics.values.throttle_L = 0
  electrics.values.throttle_R = 0
  electrics.values.throttle_M = 0




--  electrics.values.span = 0
--  electrics.values.span_updown_change = 0  

end

M.init = init
M.updateGFX = updateGFX
M.update = update

return M